com.fasterxml.jackson.core.base

## Class GeneratorBase

- java.lang.Object
- - com.fasterxml.jackson.core.JsonGenerator
  - - com.fasterxml.jackson.core.base.GeneratorBase

All Implemented Interfaces:
  Versioned, Closeable, Flushable, AutoCloseable

Direct Known Subclasses:
  JsonGeneratorImpl

    public abstract class GeneratorBase
    extends JsonGenerator

This base class implements part of API that a JSON generator exposes to applications, adds shared internal methods that sub-classes can use and adds some abstract methods sub-classes must implement.

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.core.JsonGenerator

`JsonGenerator.Feature`

### Field Summary

Fields
`protected boolean` `_cfgNumbersAsStrings` Flag set to indicate that implicit conversion from number to JSON String is needed (as per `JsonGenerator.Feature.WRITE_NUMBERS_AS_STRINGS`).
`protected boolean` `_closed` Flag that indicates whether generator is closed or not.
`protected int` `_features` Bit flag composed of bits that indicate which `JsonGenerator.Feature`s are enabled.
`protected ObjectCodec` `_objectCodec`
`protected JsonWriteContext` `_writeContext` Object that keeps track of the current contextual state of the generator.
`protected static int` `DERIVED_FEATURES_MASK` Set of feature masks related to features that need updates of other local configuration or state.
`static int` `SURR1_FIRST`
`static int` `SURR1_LAST`
`static int` `SURR2_FIRST`
`static int` `SURR2_LAST`
`protected String` `WRITE_BINARY`
`protected String` `WRITE_BOOLEAN`
`protected String` `WRITE_NULL`
`protected String` `WRITE_NUMBER`
`protected String` `WRITE_RAW`
`protected String` `WRITE_STRING`

### Fields inherited from class com.fasterxml.jackson.core.JsonGenerator

`_cfgPrettyPrinter`

### Constructor Summary

Constructors
`protected` `GeneratorBase(int features, ObjectCodec codec)`
`protected` `GeneratorBase(int features, ObjectCodec codec, JsonWriteContext ctxt)`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods Deprecated Methods
`protected void` `_checkStdFeatureChanges(int newFeatureFlags, int changedFeatures)` Helper method called to verify changes to standard features.
`protected PrettyPrinter` `_constructDefaultPrettyPrinter()` Overridable factory method called to instantiate an appropriate `PrettyPrinter` for case of "just use the default one", when `useDefaultPrettyPrinter()` is called.
`protected int` `_decodeSurrogate(int surr1, int surr2)`
`protected abstract void` `_releaseBuffers()` Method called to release any buffers generator may be holding, once generator is being closed.
`protected abstract void` `_verifyValueWrite(String typeMsg)` Method called before trying to write a value (scalar or structured), to verify that this is legal in current output state, as well as to output separators if and as necessary.
`void` `close()` Method called to close this generator, so that no more content can be written.
`JsonGenerator` `disable(JsonGenerator.Feature f)` Method for disabling specified features (check `JsonGenerator.Feature` for list of features)
`JsonGenerator` `enable(JsonGenerator.Feature f)` Method for enabling specified parser features: check `JsonGenerator.Feature` for list of available features.
`abstract void` `flush()` Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.
`ObjectCodec` `getCodec()` Method for accessing the object used for writing Java object as JSON content (using method `JsonGenerator.writeObject(java.lang.Object)`).
`Object` `getCurrentValue()` Helper method, usually equivalent to: `getOutputContext().getCurrentValue();`
`int` `getFeatureMask()` Bulk access method for getting state of all standard (non-dataformat-specific) `JsonGenerator.Feature`s.
`JsonWriteContext` `getOutputContext()` Note: co-variant return type.
`boolean` `isClosed()` Method that can be called to determine whether this generator is closed or not.
`boolean` `isEnabled(JsonGenerator.Feature f)` Method for checking whether given feature is enabled.
`JsonGenerator` `overrideStdFeatures(int values, int mask)` Bulk set method for (re)setting states of features specified by `mask`.
`JsonGenerator` `setCodec(ObjectCodec oc)` Method that can be called to set or reset the object to use for writing Java objects as JsonContent (using method `JsonGenerator.writeObject(java.lang.Object)`).
`void` `setCurrentValue(Object v)` Helper method, usually equivalent to: `getOutputContext().setCurrentValue(v);`
`JsonGenerator` `setFeatureMask(int newMask)` Deprecated.
`JsonGenerator` `useDefaultPrettyPrinter()` Convenience method for enabling pretty-printing using the default pretty printer (`DefaultPrettyPrinter`).
`Version` `version()` Implemented with standard version number detection algorithm, typically using a simple generated class, with information extracted from Maven project file during build.
`int` `writeBinary(Base64Variant b64variant, InputStream data, int dataLength)` Method similar to `JsonGenerator.writeBinary(Base64Variant,byte[],int,int)`, but where input is provided through a stream, allowing for incremental writes without holding the whole input in memory.
`void` `writeFieldName(SerializableString name)` Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.
`void` `writeObject(Object value)` Method for writing given Java object (POJO) as Json.
`void` `writeRawValue(char[] text, int offset, int len)`
`void` `writeRawValue(SerializableString text)` Method similar to `JsonGenerator.writeRawValue(String)`, but potentially more efficient as it may be able to use pre-encoded content (similar to `JsonGenerator.writeRaw(SerializableString)`.
`void` `writeRawValue(String text)` Method that will force generator to copy input text verbatim without any modifications, but assuming it must constitute a single legal JSON value (number, string, boolean, null, Array or List).
`void` `writeRawValue(String text, int offset, int len)`
`void` `writeString(SerializableString text)` Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.
`void` `writeTree(TreeNode rootNode)` Method for writing given JSON tree (expressed as a tree where given JsonNode is the root) using this generator.

### Methods inherited from class com.fasterxml.jackson.core.JsonGenerator

`_reportError, _reportUnsupportedOperation, _throwInternal, _writeSimpleObject, canOmitFields, canUseSchema, canWriteBinaryNatively, canWriteObjectId, canWriteTypeId, configure, copyCurrentEvent, copyCurrentStructure, getCharacterEscapes, getFormatFeatures, getHighestEscapedChar, getOutputBuffered, getOutputTarget, getPrettyPrinter, getSchema, overrideFormatFeatures, setCharacterEscapes, setHighestNonEscapedChar, setPrettyPrinter, setRootValueSeparator, setSchema, writeArrayFieldStart, writeBinary, writeBinary, writeBinary, writeBinary, writeBinaryField, writeBoolean, writeBooleanField, writeEndArray, writeEndObject, writeFieldName, writeNull, writeNullField, writeNumber, writeNumber, writeNumber, writeNumber, writeNumber, writeNumber, writeNumber, writeNumber, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeObjectField, writeObjectFieldStart, writeObjectId, writeObjectRef, writeOmittedField, writeRaw, writeRaw, writeRaw, writeRaw, writeRaw, writeRawUTF8String, writeStartArray, writeStartArray, writeStartObject, writeString, writeString, writeStringField, writeTypeId, writeUTF8String`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### SURR1_FIRST

    public static final int SURR1_FIRST

See Also:
  Constant Field Values

#### SURR1_LAST

    public static final int SURR1_LAST

See Also:
  Constant Field Values

#### SURR2_FIRST

    public static final int SURR2_FIRST

See Also:
  Constant Field Values

#### SURR2_LAST

    public static final int SURR2_LAST

See Also:
  Constant Field Values

#### DERIVED_FEATURES_MASK

    protected static final int DERIVED_FEATURES_MASK

Set of feature masks related to features that need updates of other local configuration or state.

Since:
  2.5

#### WRITE_BINARY

    protected final String WRITE_BINARY

See Also:
  Constant Field Values

#### WRITE_BOOLEAN

    protected final String WRITE_BOOLEAN

See Also:
  Constant Field Values

#### WRITE_NULL

    protected final String WRITE_NULL

See Also:
  Constant Field Values

#### WRITE_NUMBER

    protected final String WRITE_NUMBER

See Also:
  Constant Field Values

#### WRITE_RAW

    protected final String WRITE_RAW

See Also:
  Constant Field Values

#### WRITE_STRING

    protected final String WRITE_STRING

See Also:
  Constant Field Values

#### _objectCodec

    protected ObjectCodec _objectCodec

#### _features

    protected int _features

Bit flag composed of bits that indicate which `JsonGenerator.Feature`s are enabled.

#### _cfgNumbersAsStrings

    protected boolean _cfgNumbersAsStrings

Flag set to indicate that implicit conversion from number to JSON String is needed (as per `JsonGenerator.Feature.WRITE_NUMBERS_AS_STRINGS`).

#### _writeContext

    protected JsonWriteContext _writeContext

Object that keeps track of the current contextual state of the generator.

#### _closed

    protected boolean _closed

Flag that indicates whether generator is closed or not. Gets set when it is closed by an explicit call (`close()`).

### Constructor Detail

#### GeneratorBase

    protected GeneratorBase(int features,
                            ObjectCodec codec)

#### GeneratorBase

    protected GeneratorBase(int features,
                            ObjectCodec codec,
                            JsonWriteContext ctxt)

Since:
  2.5

### Method Detail

#### version

    public Version version()

Implemented with standard version number detection algorithm, typically using a simple generated class, with information extracted from Maven project file during build.

Specified by:
  `version` in interface `Versioned`
Specified by:
  `version` in class `JsonGenerator`

#### getCurrentValue

    public Object getCurrentValue()

Description copied from class: `JsonGenerator`
Helper method, usually equivalent to: `getOutputContext().getCurrentValue();`

Note that "current value" is NOT populated (or used) by Streaming parser; it is only used by higher-level data-binding functionality. The reason it is included here is that it can be stored and accessed hierarchically, and gets passed through data-binding.

Overrides:
  `getCurrentValue` in class `JsonGenerator`

#### setCurrentValue

    public void setCurrentValue(Object v)

Description copied from class: `JsonGenerator`
Helper method, usually equivalent to: `getOutputContext().setCurrentValue(v);`

Overrides:
  `setCurrentValue` in class `JsonGenerator`

#### isEnabled

    public final boolean isEnabled(JsonGenerator.Feature f)

Description copied from class: `JsonGenerator`
Method for checking whether given feature is enabled. Check `JsonGenerator.Feature` for list of available features.

Specified by:
  `isEnabled` in class `JsonGenerator`

#### getFeatureMask

    public int getFeatureMask()

Description copied from class: `JsonGenerator`
Bulk access method for getting state of all standard (non-dataformat-specific) `JsonGenerator.Feature`s.

Specified by:
  `getFeatureMask` in class `JsonGenerator`
Returns:
  Bit mask that defines current states of all standard `JsonGenerator.Feature`s.

#### enable

    public JsonGenerator enable(JsonGenerator.Feature f)

Description copied from class: `JsonGenerator`
Method for enabling specified parser features: check `JsonGenerator.Feature` for list of available features.

Specified by:
  `enable` in class `JsonGenerator`
Returns:
  Generator itself (this), to allow chaining

#### disable

    public JsonGenerator disable(JsonGenerator.Feature f)

Description copied from class: `JsonGenerator`
Method for disabling specified features (check `JsonGenerator.Feature` for list of features)

Specified by:
  `disable` in class `JsonGenerator`
Returns:
  Generator itself (this), to allow chaining

#### setFeatureMask

    @Deprecated
    public JsonGenerator setFeatureMask(int newMask)

Deprecated.
Description copied from class: `JsonGenerator`
Bulk set method for (re)setting states of all standard `JsonGenerator.Feature`s

Specified by:
  `setFeatureMask` in class `JsonGenerator`
Parameters:
  `newMask` - Bitmask that defines which `JsonGenerator.Feature`s are enabled and which disabled
Returns:
  This parser object, to allow chaining of calls

#### overrideStdFeatures

    public JsonGenerator overrideStdFeatures(int values,
                                             int mask)

Description copied from class: `JsonGenerator`
Bulk set method for (re)setting states of features specified by `mask`. Functionally equivalent to `int oldState = getFeatureMask(); int newState = (oldState & ~mask) | (values & mask); setFeatureMask(newState);` but preferred as this lets caller more efficiently specify actual changes made.

Overrides:
  `overrideStdFeatures` in class `JsonGenerator`
Parameters:
  `values` - Bit mask of set/clear state for features to change
  `mask` - Bit mask of features to change

#### _checkStdFeatureChanges

    protected void _checkStdFeatureChanges(int newFeatureFlags,
                                           int changedFeatures)

Helper method called to verify changes to standard features.

Parameters:
  `newFeatureFlags` - Bitflag of standard features after they were changed
  `changedFeatures` - Bitflag of standard features for which setting did change
Since:
  2.7

#### useDefaultPrettyPrinter

    public JsonGenerator useDefaultPrettyPrinter()

Description copied from class: `JsonGenerator`
Convenience method for enabling pretty-printing using the default pretty printer (`DefaultPrettyPrinter`).

Specified by:
  `useDefaultPrettyPrinter` in class `JsonGenerator`
Returns:
  Generator itself (this), to allow chaining

#### setCodec

    public JsonGenerator setCodec(ObjectCodec oc)

Description copied from class: `JsonGenerator`
Method that can be called to set or reset the object to use for writing Java objects as JsonContent (using method `JsonGenerator.writeObject(java.lang.Object)`).

Specified by:
  `setCodec` in class `JsonGenerator`
Returns:
  Generator itself (this), to allow chaining

#### getCodec

    public ObjectCodec getCodec()

Description copied from class: `JsonGenerator`
Method for accessing the object used for writing Java object as JSON content (using method `JsonGenerator.writeObject(java.lang.Object)`).

Specified by:
  `getCodec` in class `JsonGenerator`

#### getOutputContext

    public JsonWriteContext getOutputContext()

Note: co-variant return type.

Specified by:
  `getOutputContext` in class `JsonGenerator`
Returns:
  Context object that can give information about logical position within generated json content.

#### writeFieldName

    public void writeFieldName(SerializableString name)
                        throws IOException

Description copied from class: `JsonGenerator`
Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.

Default implementation simple uses unprocessed name container in serialized String; implementations are strongly encouraged to make use of more efficient methods argument object has.

Specified by:
  `writeFieldName` in class `JsonGenerator`
Throws:
  `IOException`

#### writeString

    public void writeString(SerializableString text)
                     throws IOException

Description copied from class: `JsonGenerator`
Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.

Default implementation just calls `JsonGenerator.writeString(String)`; sub-classes should override it with more efficient implementation if possible.

Specified by:
  `writeString` in class `JsonGenerator`
Throws:
  `IOException`

#### writeRawValue

    public void writeRawValue(String text)
                       throws IOException

Description copied from class: `JsonGenerator`
Method that will force generator to copy input text verbatim without any modifications, but assuming it must constitute a single legal JSON value (number, string, boolean, null, Array or List). Assuming this, proper separators are added if and as needed (comma or colon), and generator state updated to reflect this.

Specified by:
  `writeRawValue` in class `JsonGenerator`
Throws:
  `IOException`

#### writeRawValue

    public void writeRawValue(String text,
                              int offset,
                              int len)
                       throws IOException

Specified by:
  `writeRawValue` in class `JsonGenerator`
Throws:
  `IOException`

#### writeRawValue

    public void writeRawValue(char[] text,
                              int offset,
                              int len)
                       throws IOException

Specified by:
  `writeRawValue` in class `JsonGenerator`
Throws:
  `IOException`

#### writeRawValue

    public void writeRawValue(SerializableString text)
                       throws IOException

Description copied from class: `JsonGenerator`
Method similar to `JsonGenerator.writeRawValue(String)`, but potentially more efficient as it may be able to use pre-encoded content (similar to `JsonGenerator.writeRaw(SerializableString)`.

Overrides:
  `writeRawValue` in class `JsonGenerator`
Throws:
  `IOException`

#### writeBinary

    public int writeBinary(Base64Variant b64variant,
                           InputStream data,
                           int dataLength)
                    throws IOException

Description copied from class: `JsonGenerator`
Method similar to `JsonGenerator.writeBinary(Base64Variant,byte[],int,int)`, but where input is provided through a stream, allowing for incremental writes without holding the whole input in memory.

Specified by:
  `writeBinary` in class `JsonGenerator`
Parameters:
  `b64variant` - Base64 variant to use
  `data` - InputStream to use for reading binary data to write. Will not be closed after successful write operation
  `dataLength` - (optional) number of bytes that will be available; or -1 to be indicate it is not known. If a positive length is given, `data` MUST provide at least that many bytes: if not, an exception will be thrown. Note that implementations need not support cases where length is not known in advance; this depends on underlying data format: JSON output does NOT require length, other formats may.
Returns:
  Number of bytes read from `data` and written as binary payload
Throws:
  `IOException`

#### writeObject

    public void writeObject(Object value)
                     throws IOException

Description copied from class: `JsonGenerator`
Method for writing given Java object (POJO) as Json. Exactly how the object gets written depends on object in question (ad on codec, its configuration); for most beans it will result in JSON Object, but for others JSON Array, or String or numeric value (and for nulls, JSON null literal. NOTE: generator must have its object codec set to non-null value; for generators created by a mapping factory this is the case, for others not.

Specified by:
  `writeObject` in class `JsonGenerator`
Throws:
  `IOException`

#### writeTree

    public void writeTree(TreeNode rootNode)
                   throws IOException

Description copied from class: `JsonGenerator`
Method for writing given JSON tree (expressed as a tree where given JsonNode is the root) using this generator. This will generally just call `JsonGenerator.writeObject(java.lang.Object)` with given node, but is added for convenience and to make code more explicit in cases where it deals specifically with trees.

Specified by:
  `writeTree` in class `JsonGenerator`
Throws:
  `IOException`

#### flush

    public abstract void flush()
                        throws IOException

Description copied from class: `JsonGenerator`
Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.

Specified by:
  `flush` in interface `Flushable`
Specified by:
  `flush` in class `JsonGenerator`
Throws:
  `IOException`

#### close

    public void close()
               throws IOException

Description copied from class: `JsonGenerator`
Method called to close this generator, so that no more content can be written.

Whether the underlying target (stream, writer) gets closed depends on whether this generator either manages the target (i.e. is the only one with access to the target -- case if caller passes a reference to the resource such as File, but not stream); or has feature `JsonGenerator.Feature.AUTO_CLOSE_TARGET` enabled. If either of above is true, the target is also closed. Otherwise (not managing, feature not enabled), target is not closed.

Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in class `JsonGenerator`
Throws:
  `IOException`

#### isClosed

    public boolean isClosed()

Description copied from class: `JsonGenerator`
Method that can be called to determine whether this generator is closed or not. If it is closed, no more output can be done.

Specified by:
  `isClosed` in class `JsonGenerator`

#### _releaseBuffers

    protected abstract void _releaseBuffers()

Method called to release any buffers generator may be holding, once generator is being closed.

#### _verifyValueWrite

    protected abstract void _verifyValueWrite(String typeMsg)
                                       throws IOException

Method called before trying to write a value (scalar or structured), to verify that this is legal in current output state, as well as to output separators if and as necessary.

Parameters:
  `typeMsg` - Additional message used for generating exception message if value output is NOT legal in current generator output state.
Throws:
  `IOException`

#### _constructDefaultPrettyPrinter

    protected PrettyPrinter _constructDefaultPrettyPrinter()

Overridable factory method called to instantiate an appropriate `PrettyPrinter` for case of "just use the default one", when `useDefaultPrettyPrinter()` is called.

Since:
  2.6

#### _decodeSurrogate

    protected final int _decodeSurrogate(int surr1,
                                         int surr2)
                                  throws IOException

Throws:
  `IOException`
Since:
  2.5